## castle-game-engine 4.1.1

=== Makefile ===
# Most useful targets:
#
#   all (default target) --
#     Compile all units, uses fpmake.
#
#   examples --
#     Compile examples and tools (inside examples/ subdirectory).
#     This compilation method uses our xxx_compile.sh Unix scripts,
#     and requires only pure FPC installation.
#     Lazarus is not required (LCL dependent examples are not compiled).
#     Note that you can also compile each example separately,
#     just execute directly appropriate xxx_compile.sh scripts.
#
#   examples-laz --
#     Compile examples and tools (inside examples/ subdirectory).
#     This compilation method uses our .lpi project files,
#     and compiles every program by the lazbuild utility.
#     Lazarus and FPC installation is required, and Lazarus must know
#     about the castle_* packages (compile them from Lazarus first).
#
#   clean --
#     Delete FPC 1.0.x Windows trash (*.ppw, *.ow), FPC trash, Delphi trash,
#     Lazarus trash (*.compiled),
#     binaries of example programs,
#     also FPC compiled trash in packages/*/lib/.
#
# Not-so-commonly-useful targets:
#
#   cleanmore --
#     Same as clean, and also delete:
#     - Emacs backup files (*~) and
#     - Delphi backup files (*.~???)
#     - pasdoc generated documentation in doc/pasdoc/
#
#   cleanall --
#     Same as cleanmore for now.
#     Intention is to remove *everything* that can be manually recreated,
#     even if somewhat hard, and clean editor backup.

# compiling ------------------------------------------------------------

.PHONY: all
all:
	fpc fpmake.pp
	@echo 'Running fpmake. If this fails saying that "rtl" is not found, remember to set FPCDIR environment variable, see http://wiki.freepascal.org/FPMake .'
	./fpmake

# examples and tools -----------------------------------------------------------

# Note that images/examples/fft_tests is not included here,
# and unit images/imagesfftw.pas is not included in fpmake.pp,
# because
# 1. it requires to compile FPC > 2.2.x, and we try to work also with earlier FPC.
# 2. to link the example, you need the fftw library. I don't want
#    to force everyone who wants to execute "make examples" to install
#    fftw library (especially since it's really not needed by my engine,
#    currently my fftw code is just for testing, it's not actually used
#    by our engine or any game for anything).

EXAMPLES_BASE_NAMES := \
  examples/audio/algets \
  examples/audio/alplay \
  examples/audio/doppler_demo \
  examples/audio/efx_demo \
  examples/tools/dircleaner \
  examples/tools/stringoper \
  examples/tools/castle_download \
  examples/tools/to_data_uri \
  examples/castlescript/castle_calculator \
  examples/castlescript/image_make_by_script \
  examples/images_videos/image_convert \
  examples/images_videos/dds_decompose \
  examples/images_videos/image_identify \
  examples/images_videos/image_to_pas \
  examples/images_videos/image_compare \
  examples/images_videos/simple_video_editor \
  examples/fonts/test_font_break \
  examples/window/window_events \
  examples/window/window_menu \
  examples/window/window_gtk_mix \
  examples/window/multi_window \
  examples/curves_surfaces/bezier_surfaces/animate_surface \
  examples/curves_surfaces/bezier_surfaces/design_surface \
  examples/curves_surfaces/interpolated_curves \
  examples/space_filling_curve/draw_space_filling_curve \
  examples/radiance_transfer/radiance_transfer \
  examples/radiance_transfer/precompute_radiance_transfer \
  examples/radiance_transfer/show_sh \
  examples/shadow_fields/precompute_shadow_field \
  examples/shadow_fields/shadow_fields \
  examples/dynamic_ambient_occlusion/dynamic_ambient_occlusion \
  examples/terrain/terrain \
  examples/3d_rendering_processing/custom_3d_object \
  examples/3d_rendering_processing/triangulate_demo \
  examples/3d_rendering_processing/placeholder_names \
  examples/3d_rendering_processing/tools/gen_light_map \
  examples/3d_rendering_processing/tools/kanim_to_interpolators \
  examples/3d_rendering_processing/multiple_viewports \
  examples/3d_rendering_processing/fog_culling \
  examples/3d_rendering_processing/plane_mirror_and_shadow \
  examples/3d_rendering_processing/animate_3d_model_by_code \
  examples/3d_rendering_processing/animate_3d_model_by_code_2 \
  examples/3d_rendering_processing/call_pascal_code_from_3d_model_script \
  examples/3d_rendering_processing/view_3d_model_advanced \
  examples/3d_rendering_processing/scene_manager_demos \
  examples/3d_rendering_processing/view_3d_model_basic \
  examples/3d_rendering_processing/build_3d_object_by_code \
  src/x3d/teapot/teapot_3d_to_pascal \
  examples/fixed_camera_game/rift \
  examples/isometric_game/sandbox \
  examples/images_videos/gaussian_write \
  examples/3d_sound_game/lets_take_a_walk \
  examples/3d_sound_game/data/levels/base/devel/process_base_b \
  examples/resource_animations/resource_animations \
  examples/fps_game/fps_game

EXAMPLES_LAZARUS_BASE_NAMES := \
  examples/audio/test_al_source_allocator \
  examples/lazarus/model_3d_viewer/model_3d_viewer \
  examples/lazarus/model_3d_with_2d_controls/model_3d_with_2d_controls \
  examples/lazarus/load_model_and_camera_manually/load_model_and_camera_manually \
  examples/lazarus/two_controls/two_controls \
  tests/test_castle_game_engine

EXAMPLES_UNIX_EXECUTABLES := $(EXAMPLES_BASE_NAMES) \
  $(EXAMPLES_LAZARUS_BASE_NAMES)

EXAMPLES_WINDOWS_EXECUTABLES := $(addsuffix .exe,$(EXAMPLES_BASE_NAMES)) \
  $(addsuffix .exe,$(EXAMPLES_LAZARUS_BASE_NAMES)) \
  examples/fonts/font2pascal.exe

EXAMPLES_MACOSX_APPS := $(addsuffix .app,$(EXAMPLES_BASE_NAMES)) \
  $(addsuffix .app,$(EXAMPLES_LAZARUS_BASE_NAMES))

EXAMPLES_RES_FILES := $(addsuffix .res,$(EXAMPLES_BASE_NAMES)) \
  $(addsuffix .res,$(EXAMPLES_LAZARUS_BASE_NAMES))

.PHONY: examples
examples:
	$(foreach NAME,$(EXAMPLES_BASE_NAMES),$(NAME)_compile.sh && ) true

.PHONY: examples-ignore-errors
examples-ignore-errors:
	$(foreach NAME,$(EXAMPLES_BASE_NAMES),$(NAME)_compile.sh ; ) true

.PHONY: cleanexamples
cleanexamples:
	rm -f $(EXAMPLES_UNIX_EXECUTABLES) $(EXAMPLES_WINDOWS_EXECUTABLES) $(EXAMPLES_RES_FILES)
	rm -Rf $(EXAMPLES_MACOSX_APPS)

.PHONY: examples-laz
examples-laz:
	lazbuild packages/castle_base.lpk
	lazbuild packages/castle_window.lpk
	lazbuild packages/castle_components.lpk
	$(foreach NAME,$(EXAMPLES_BASE_NAMES) $(EXAMPLES_LAZARUS_BASE_NAMES),lazbuild $(NAME).lpi && ) true

# cleaning ------------------------------------------------------------

.PHONY: clean cleanmore cleanall

clean: cleanexamples
	find . -type f '(' -iname '*.ow'  -or -iname '*.ppw' -or -iname '*.aw' -or \
	                   -iname '*.o'   -or -iname '*.ppu' -or -iname '*.a' -or \
			   -iname '*.or'  -or \
			   -iname '*.compiled' -or \
			   -iname '*.libimp*.a' -or \
	                   -iname '*.dcu' -or -iname '*.dpu' ')' \
	     -print \
	     | xargs rm -f
	find . -type d -name lib -exec rm -Rf '{}' ';' -prune
	rm -Rf packages/castle_base.pas \
	  packages/castle_window.pas \
	  packages/castle_components.pas \
	  packages/alternative_castle_window_based_on_lcl.pas \
	  tests/test_castle_game_engine tests/test_castle_game_engine.exe
# fpmake binary, and units/ produced by fpmake compilation
	rm -Rf fpmake fpmake.exe units/
# lazarus produces lib/ subdirectories during compilation
	find examples/ -type d -name lib -prune -exec rm -Rf '{}' ';'

cleanmore: clean
	find . -type f '(' -iname '*~' -or \
	                   -iname '*.bak' -or \
	                   -iname '*.~???' -or \
			   -iname '*.blend1' \
			')' -exec rm -f '{}' ';'
	$(MAKE) -C doc/pasdoc/ clean

cleanall: cleanmore

# Clean compiled versions of CastleWindow unit.
# Makes sure that unit CastleWindow will be *always* *rebuild* in next compilation.
#
# This is useful, since CastleWindow unit may be compiled with various
# back-ends (e.g. under Unices two most useful back-ends
# are XLIB and GTK). To make sure that compilation of some program
# will produce exactly what you need, it's useful to force rebuild of CastleWindow.
#
# Of course this means that compilation time will suffer a little,
# since CastleWindow unit will be possibly rebuild without any real need.
clean-window:
	rm -f src/window/castlewindow.o \
	      src/window/castlewindow.ppu \
	      src/window/CastleWindow.o \
	      src/window/CastleWindow.ppu

# ----------------------------------------
# Set SVN tag.

svntag:
	source ../www/pack/generated_versions.sh && \
	  svn copy https://svn.code.sf.net/p/castle-engine/code/trunk/castle_game_engine \
	           https://svn.code.sf.net/p/castle-engine/code/tags/castle_game_engine/"$$GENERATED_VERSION_CASTLE_GAME_ENGINE" \
	  -m "Tagging the $$GENERATED_VERSION_CASTLE_GAME_ENGINE version of 'Castle Game Engine'."

# eof ------------------------------------------------------------

=== doc/pasdoc/Makefile ===
# Main targets to gen final docs ----------------------------------------

.PHONY: default html pdf ps rtf latex

# html and pdf are two most useful versions of documentation,
# shown on [http://castle-engine.sourceforge.net/reference.php]
# Later: pdf now removed, useless and ugly
default: html

html:
	./mk_docs.sh html
	cp $(CASTLE_ENGINE_PATH)www/htdocs/images/castle_game_engine_icon.png html/

# Just some shortcuts to "Helpful targets" below
pdf: latex/docs.pdf
ps: latex/docs.ps
rtf: latex2rtf/docs.rtf
latex: latex/docs.tex

# Helpful targets to gen docs ----------------------------------------

latex2rtf/docs.tex:
	./mk_docs.sh latex2rtf

latex2rtf/docs.rtf: latex2rtf/docs.tex
	cd latex2rtf; latex2rtf docs.tex

latex/docs.tex:
	./mk_docs.sh latex

TEX_BATCH_OPTS := --file-line-error-style -interaction=nonstopmode

latex/docs.dvi: latex/docs.tex
	-cd latex; latex $(TEX_BATCH_OPTS) docs.tex
	-cd latex; latex $(TEX_BATCH_OPTS) docs.tex

# At the end of pdf generating, we clean useless junk
# (because it's quite large, and I may want to upload latex/
# dir to WWW page of my units)
latex/docs.pdf: latex/docs.tex
	-cd latex; pdflatex $(TEX_BATCH_OPTS) docs.tex
	-cd latex; pdflatex $(TEX_BATCH_OPTS) docs.tex
	rm -f latex/docs.aux \
	      latex/docs.log \
	      latex/docs.out \
	      latex/docs.toc

latex/docs.ps: latex/docs.dvi
	cd latex; dvips docs.dvi -o docs.ps

# Cleaning ------------------------------------------------------------

.PHONY: clean-cache clean

clean-cache:
	rm -fR cache/

clean: clean-cache
	rm -Rf html/ latex/ latex2rtf/

# upload ---------------------------------------------------------------------

SF_USERNAME=kambi
SF_HOST=web.sourceforge.net
SF_PATH=/home/project-web/castle-engine/htdocs/apidoc/

SF_CONNECT=$(SF_USERNAME),castle-engine@$(SF_HOST):$(SF_PATH)
SCP_OPTIONS=

# Prepare and upload all the stuff referenced under
# [http://castle-engine.sourceforge.net/reference.php].
# Uploads as tar.gz and unpacks on server, this is *much* faster than
# uploading separate HTML files.
.PHONY: upload
upload: clean html
	tar czvf html.tar.gz html/
	scp $(SCP_OPTIONS) -r html.tar.gz $(SF_CONNECT)
	./sf_upload_finalize.sh $(SF_USERNAME) $(SF_PATH)

=== examples/3d_sound_game/Makefile ===
# Note about file_to_pascal_string: it's another program of mine,
# you can get it from pasdoc [http://pasdoc.sourceforge.net/] sources.
help_message.inc: help_message.txt
	file_to_pascal_string help_message.txt help_message.inc

# Simple install.
# You may as well symlink data to /usr/local/share/lets_take_a_walk,
# for system-wide install.
install:
	rm -f $(HOME)/.local/share/lets_take_a_walk
	ln -s $(shell pwd)/data $(HOME)/.local/share/lets_take_a_walk

=== examples/isometric_game/Makefile ===
# Simple install.
# You may as well symlink to /usr/local/share/sandbox,
# for system-wide install.
install:
	rm -f $(HOME)/.local/share/sandbox
	ln -s $(shell pwd) $(HOME)/.local/share/sandbox

=== examples/3d_rendering_processing/tools/Makefile ===
# This requires file_to_pascal_string that is a trivial program
# that I made for pasdoc [http://pasdoc.sf.net/] project, see
# [https://pasdoc.svn.sourceforge.net/svnroot/pasdoc/trunk/source/tools/file_to_pascal_string.dpr]

ALL_OUTPUT := x3d_nodes_spec_to_pascal_preamble.inc \
	      kanim_to_interpolators_suffix.inc

.PHONY: all
all: $(ALL_OUTPUT);

x3d_nodes_spec_to_pascal_preamble.inc: x3d_nodes_spec_to_pascal_preamble.txt
	file_to_pascal_string $< $@

kanim_to_interpolators_suffix.inc: kanim_to_interpolators_suffix.x3dv
	file_to_pascal_string $< $@

.PHONY: clean
clean:
	rm -f $(ALL_OUTPUT)

=== src/components/icons/Makefile ===
castleicons.lrs: *.png
	lazres castleicons.lrs *.png

=== src/ui/opengl/gui-images/Makefile ===
.PHONY: all clean

ALL_UNITS=../castleonscreenmenuimages.pas

all: $(ALL_UNITS)

clean:
	rm -f $(ALL_UNITS)

../castleonscreenmenuimages.pas: slider_base.png slider_position.png
	image_to_pas --output .. CastleOnScreenMenuImages $^

=== src/x3d/opengl/glsl/Makefile ===
# Note about file_to_pascal_string: it's another program of mine,
# you can get it from pasdoc [http://pasdoc.sourceforge.net/] sources.

ALL_OUTPUT := shadow_map_common.fs.inc \
  variance_shadow_map_common.fs.inc \
  variance_shadow_map_generate.fs.inc \
  template.vs.inc template.fs.inc template.gs.inc \
  template_add_light.glsl.inc \
  ssao.glsl.inc screen_effect_library.glsl.inc

.PHONY: all
all: $(ALL_OUTPUT)

%.inc: %
	file_to_pascal_string $< $@

.PHONY: clean
clean:
	rm -f $(ALL_OUTPUT)

=== debian/changelog ===
castle-game-engine (4.1.1-1) unstable; urgency=low

  * New upstream release
    - Drop all patches, applied upstream
    - Add fp-units-net to Build-depends
  * Add myself to uploaders
  * Reorganize d/rules

 -- Paul Gevers <elbrus@debian.org>  Sun, 08 Sep 2013 21:18:46 +0200

castle-game-engine (4.0.1-1) unstable; urgency=low

  * Packaged Castle Game Engine for Debian. (Closes: Bug#706408)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sat, 27 Apr 2013 18:06:40 +0100

=== debian/control ===
Source: castle-game-engine
Section: misc
Priority: optional
Maintainer: Abou Al Montacir <abou.almontacir@sfr.fr>
Uploaders: Paul Gevers <elbrus@debian.org>
Standards-Version: 3.9.4
Build-Depends:
 debhelper (>= 7),
 fp-compiler,
 fp-units-base,
 fp-units-fcl,
 fp-units-gfx,
 fp-units-gtk2,
 fp-units-multimedia,
 fp-units-net,
 fp-utils (>= 2.6.2),
 quilt
Vcs-Git: http://code.google.com/p/pascal-for-debian.castle-game-engine
Vcs-Browser: http://code.google.com/p/pascal-for-debian/source/browse/?repo=castle-game-engine
Homepage: http://castle-engine.sourceforge.net/engine.php

Package: fp-units-castle-game-engine
Architecture: amd64 i386
Depends:
 ${fpc-abi:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 castle-game-engine-src
Description: Castle Game Engine - 3D game engine for FreePascal / Lazarus
 Castle Game Engine is a set of LGPL licenced libraries that are inteded to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains the FPC units.

Package: castle-game-engine-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Suggests:
 castle-game-engine-src,
 fp-units-castle-game-engine
Description: Castle Game Engine - Developer's Documentation
 Castle Game Engine is a set of LGPL licenced libraries that are inteded to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains documentation.

Package: castle-game-engine-src
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 fp-units-castle-game-engine
Description: Castle Game Engine - Source code for Lazarus integration
 Castle Game Engine is a set of LGPL licenced libraries that are inteded to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains source code for integration with Lazarus RAD IDE.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Castle Game Engine

DEB_PACKAGE_NAME=castle-game-engine
DEB_DH_BUILDDEB_ARGS := -- -Z bzip2
export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
export LANG:=C

# Documentation type to use chm/html
ifeq (${DEBDOCTYPE},)
DOCTYPE=html
# HTML Converter chmdocs or htmldocs for (default)
CONVERTER=${DOCTYPE}docs
else
DOCTYPE=${DEBDOCTYPE}
CONVERTER=${DOCTYPE}docs
endif
# Define FPC
ifndef FPC
FPC=/usr/bin/fpc
endif
# Set FPCVER
FPCVER=$(shell ${FPC} -iV)

CPU_TARGET?=$(shell ${FPC} -iTP)
OS_TARGET?=$(shell ${FPC} -iTO)
FPCTARGET=${CPU_TARGET}-${OS_TARGET}
# Get version information from changelog file
DEB_VERSION:=$(shell dpkg-parsechangelog | grep '^Version:' | cut -f 2 -d ' ')
DEB_UPSTREAM_VERSION:=$(shell echo $(DEB_VERSION) | cut -f 1 -d -)
DEB_UPSTREAM_MAIN_VERSION:=$(shell echo ${DEB_UPSTREAM_VERSION} | sed -e 's/^\([0-9\.]*\).*/\1/')
DEB_BUILD=$(lastword $(subst -, ,${DEB_VERSION}))
ifndef PACKAGESUFFIX
PACKAGESUFFIX=-${DEB_UPSTREAM_MAIN_VERSION}
endif
DEB_HOST_MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# Get directories
CURDIR:=$(shell pwd)
INSTALL_DIR=$(CURDIR)/debian/tmp
LIB_DIR=${INSTALL_DIR}/usr/lib/${DEB_PACKAGE_NAME}/${DEB_UPSTREAM_MAIN_VERSION}
SRC_DIR=${INSTALL_DIR}/usr/src/${DEB_PACKAGE_NAME}-${DEB_UPSTREAM_MAIN_VERSION}
UNITS_DIR=${INSTALL_DIR}/usr/lib/${DEB_HOST_MULTIARCH}/fp-units-${FPCVER}/${DEB_PACKAGE_NAME}-${DEB_UPSTREAM_MAIN_VERSION}
# Get utils
ifndef MKDIR
MKDIR=mkdir -p
endif
ifndef CP
CP=cp -Rfpl
endif
RM:=rm -rf
# Get fpcmake from path if none is specified.
ifndef FPCMAKE
FPCMAKE=fpcmake
endif
# Define FPCDIR if it was not set
ifndef FPCDIR
export FPCDIR=/usr/lib/fpc/${FPCVER}
endif
ifndef LAZBUILD
LAZBUILD=lazbuild
endif
# Set default compilation options
BUILDOPTS=

# Configure patch system
include /usr/share/quilt/quilt.make

#export DH_VERBOSE=1

###################
# Clean
#

clean: patch configure clean-patched unpatch
	# Remove auto-generated make files.
	find -name Makefile.fpc -execdir 'sh' '-c' '${RM} $$(basename {} .fpc)' ';'
	# dh_clean gets a list of files from the debian/clean file
	dh_clean
clean-patched:
	@echo "--- Cleaning"
	dh_testdir
	$(MAKE) clean
	dh_prep

###################
# Arch packages
#

configure: patch configure-stamp
configure-stamp:
	dh_testdir
	# Remove auto-generated make files.
	find -name Makefile.fpc -execdir 'sh' '-c' '${RM} $$(basename {} .fpc)' ';'
#	# Regenrate make files using fpcmake.
#	${FPCMAKE} -r -Tall
#	# Remove auto-generated version file.
#	${RM} ide/version.inc
#	# Add version.inc:
#	echo \'$(DEB_VERSION)\' > version.inc
	touch configure-stamp

build-arch: configure build-arch-stamp
build-arch-stamp:
	@echo "--- Building"
	dh_testdir
	${MAKE} all
	touch build-arch-stamp

install-arch: build-arch install-arch-stamp
install-arch-stamp:
	@echo "--- Installing"
	dh_testdir
	dh_testroot
	dh_installdirs
	# Install units
	${MKDIR} ${UNITS_DIR}
	${CP} -t ${UNITS_DIR} units/${FPCTARGET}/*
	# copy images, sounds, icons and menu entries for the GNOME menu
	#${MKDIR} $(INSTALL_DIR)/usr/share
	#${CP} -t $(INSTALL_DIR)/usr/share \
	#  build/share/applications \
	#  build/share/icons \
	#  build/share/images \
	#  build/share/locale \
	#  build/share/man \
	#  build/share/sounds
	# Mark package as manually compilable and install them
	for package in $$(find * -name '*.lpk') ; \
	do \
		pkgDir=$$(dirname "${LIB_DIR}/$${package}") ; \
		${MKDIR} "$${pkgDir}" ; \
		sed -e 's@\(\W*\)<CompilerOptions>.*@\1<AutoUpdate Value="Manually"/>\n&@' \
		    -e "s@\.\./src/@$$(relpath ${SRC_DIR} $${pkgDir})/@g" \
			-e "s@\(\W*\)<UnitOutputDirectory .*@<UnitOutputDirectory Value=\"$$(relpath ${UNITS_DIR} $${pkgDir})\"/>@" \
		    "$${package}" > "${LIB_DIR}/$${package}" ; \
	done
	find ${INSTALL_DIR} -empty -delete
	touch install-arch-stamp

build-indep: configure build-doc
install-indep: install-doc install-source

###################
# Documentation
#

build-doc: patch build-doc-stamp
build-doc-stamp:
	@echo "--- Building Documentation"
	dh_testdir
	# Need to active the next line when pasdoc is packaged for Debian
#	${MAKE} -C doc/pasdoc ${CONVERTER} ${BUILDOPTS}
	touch build-doc-stamp

install-doc: build-doc install-doc-stamp
install-doc-stamp:
	@echo "--- Installing Documentation"
	dh_testdir
	dh_testroot
	# No need to do anything now as we take specific docs straight
	# from the source dir with dh_installdocs in the binary-indep target
	touch install-doc-stamp

###################
# Source
#

install-source: install-source-stamp
install-source-stamp:
	@echo "--- Cleaning the tree and copying the source code"
	dh_testdir
	dh_testroot
	${MKDIR} ${SRC_DIR}
	${CP} -t ${SRC_DIR} \
		$(CURDIR)/src/*
	find $(INSTALL_DIR) -name '*.bmp' -exec chmod 644 '{}' ';'
	find ${SRC_DIR} -empty -delete
	touch install-source-stamp

###################
# Generic
#

build: build-arch build-indep
install: install-arch install-indep
binary: binary-arch binary-indep


###################
# Deb building
#

binary-indep: install-indep
	@echo "--- Building: arch-indep packages"
	dh_testdir
	dh_testroot
	dh_installdocs -i -X.in
	dh_installchangelogs -i
	dh_install -i --list-missing
	dh_lintian

ifeq (${DEB_BUILD},0)
	# We are building upstream debs, install override files for build = 0
	set -x -e ; cd debian ; for PACKAGE in `sed -n -e 's/Package: \(.*\)/\1/p' control` ; do \
	  if [ -d $${PACKAGE} ] ; \
	  then \
	    ${MKDIR} $${PACKAGE}/usr/share/lintian/overrides ; \
	    echo "$${PACKAGE}: debian-revision-should-not-be-zero" >> $${PACKAGE}/usr/share/lintian/overrides/$${PACKAGE} ; \
	  fi ; \
	done
endif
	dh_compress -i -X.pdf
	dh_fixperms
	dh_installdebconf -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i $(DEB_DH_BUILDDEB_ARGS)

binary-arch: install-arch
	@echo "--- Building: arch packages"
	dh_testdir
	dh_testroot
	dh_link
	dh_installdocs -a -X.in
	dh_installchangelogs -a
	dh_installexamples -a
	dh_install -a --list-missing
	dh_lintian
	dh_installmenu
	fpc-depends
	dh_installman -s
	dh_strip -s
	dh_compress -a
	dh_fixperms
	dh_installdebconf -a
	dh_installdeb -a
	dh_shlibdeps -s
	dh_gencontrol -s
	dh_md5sums -s
	dh_builddeb -s $(DEB_DH_BUILDDEB_ARGS)

.PHONY: build clean binary binary-arch \
	binary-indep build-arch \
	install install-indep install-arch \
	configure

get-orig-source:
	-uscan --upstream-version=0 --rename

## castle-game-engine 5.0.0

=== Makefile ===
--- 
+++ 
@@ -75,6 +75,8 @@
   examples/images_videos/image_compare \
   examples/images_videos/simple_video_editor \
   examples/fonts/test_font_break \
+  examples/fonts/font_from_texture \
+  examples/fonts/texturefont2pascal \
   examples/window/window_events \
   examples/window/window_menu \
   examples/window/window_gtk_mix \
@@ -112,7 +114,9 @@
   examples/3d_sound_game/lets_take_a_walk \
   examples/3d_sound_game/data/levels/base/devel/process_base_b \
   examples/resource_animations/resource_animations \
-  examples/fps_game/fps_game
+  examples/fps_game/fps_game \
+  examples/2d/controls_demo \
+  examples/android/android_demo/androiddemo_standalone
 
 EXAMPLES_LAZARUS_BASE_NAMES := \
   examples/audio/test_al_source_allocator \
@@ -120,14 +124,16 @@
   examples/lazarus/model_3d_with_2d_controls/model_3d_with_2d_controls \
   examples/lazarus/load_model_and_camera_manually/load_model_and_camera_manually \
   examples/lazarus/two_controls/two_controls \
-  tests/test_castle_game_engine
+  tests/test_castle_game_engine \
+  src/library/castleengine \
+  examples/library/lcl_dynlib_tester/cge_dynlib_tester
 
 EXAMPLES_UNIX_EXECUTABLES := $(EXAMPLES_BASE_NAMES) \
   $(EXAMPLES_LAZARUS_BASE_NAMES)
 
 EXAMPLES_WINDOWS_EXECUTABLES := $(addsuffix .exe,$(EXAMPLES_BASE_NAMES)) \
   $(addsuffix .exe,$(EXAMPLES_LAZARUS_BASE_NAMES)) \
-  examples/fonts/font2pascal.exe
+  examples/fonts/outlinefont2pascal.exe
 
 EXAMPLES_MACOSX_APPS := $(addsuffix .app,$(EXAMPLES_BASE_NAMES)) \
   $(addsuffix .app,$(EXAMPLES_LAZARUS_BASE_NAMES))
@@ -163,21 +169,26 @@
 	find . -type f '(' -iname '*.ow'  -or -iname '*.ppw' -or -iname '*.aw' -or \
 	                   -iname '*.o'   -or -iname '*.ppu' -or -iname '*.a' -or \
 			   -iname '*.or'  -or \
+			   -iname '*.rsj' -or \
 			   -iname '*.compiled' -or \
 			   -iname '*.libimp*.a' -or \
-	                   -iname '*.dcu' -or -iname '*.dpu' ')' \
+	                   -iname '*.dcu' -or -iname '*.dpu' -or \
+			   -iname 'castleengine.dll' -or -iname 'libcastleengine.so' ')' \
 	     -print \
 	     | xargs rm -f
 	find . -type d -name lib -exec rm -Rf '{}' ';' -prune
 	rm -Rf packages/castle_base.pas \
 	  packages/castle_window.pas \
 	  packages/castle_components.pas \
+	  packages/castle_android_utilities.pas \
 	  packages/alternative_castle_window_based_on_lcl.pas \
 	  tests/test_castle_game_engine tests/test_castle_game_engine.exe
 # fpmake binary, and units/ produced by fpmake compilation
 	rm -Rf fpmake fpmake.exe units/
 # lazarus produces lib/ subdirectories during compilation
 	find examples/ -type d -name lib -prune -exec rm -Rf '{}' ';'
+	$(MAKE) clean -C examples/android/android_demo/android/
+	$(MAKE) clean -C examples/android/drawing_toy/android/
 
 cleanmore: clean
 	find . -type f '(' -iname '*~' -or \

=== examples/fixed_camera_game/Makefile ===
default:
	@echo 'No default target in this Makefile'

# Simple install.
# You may as well symlink data to /usr/local/share/rift,
# for system-wide install.
install:
	rm -f $(HOME)/.local/share/rift
	ln -s $(shell pwd)/data $(HOME)/.local/share/rift

=== examples/android/android_demo/android/Makefile ===
.PHONY: release
release: data
	cd ../ && sh compile.sh -dRELEASE
	mkdir -p libs/armeabi/
	mv -f ../libandroiddemo.so libs/armeabi/libandroiddemo.so
	ant debug
	adb install -r bin/AndroidDemo-debug.apk
	adb shell am start -a android.intent.action.MAIN -n net.sourceforge.castleengine.androiddemo/android.app.NativeActivity

# Debug version of the app with debug information
.PHONY: debug
debug: data
	cd ../ && sh compile.sh -dDEBUG
	mkdir -p libs/armeabi/
	mv -f ../libandroiddemo.so jni/libandroiddemo.so
	export NDK_DEBUG=1 && ndk-build
	ant debug
	adb install -r bin/AndroidDemo-debug.apk
	adb shell am start -a android.intent.action.MAIN -n net.sourceforge.castleengine.androiddemo/android.app.NativeActivity

.PHONY: clean
clean:
	rm -Rf bin/ gen/ libs/ obj/ assets/ jni/libandroiddemo.so

.PHONY: data
data:
	rm -Rf assets/
	cp -R ../data/ assets/
	find assets/ -type f \
	   '(' -iname '*~' -or \
	       -iname '*.blend1' -or \
	       -iname '*.blend2' ')' \
	   -exec rm -f '{}' ';'

=== examples/android/drawing_toy/android/Makefile ===
FPC_OPTIONS:=-CfVFPV3

.PHONY: release
release: data
	cd ../../../../ && ppcrossarm -Tandroid $(FPC_OPTIONS) -dRELEASE ${CASTLE_FPC_OPTIONS:-} @castle-fpc.cfg examples/android/drawing_toy/drawing_toy.lpr
	mkdir -p libs/armeabi/
	mv -f ../libdrawing_toy.so libs/armeabi/libdrawing_toy.so
	ant debug
#	adb uninstall net.sourceforge.castleengine.drawingtoy
	adb install -r bin/DrawingToy-debug.apk
	adb shell am start -a android.intent.action.MAIN -n net.sourceforge.castleengine.drawingtoy/android.app.NativeActivity

# Debug version of the app with debug information
.PHONY: debug
debug: data
	cd ../../../../ && ppcrossarm -Tandroid $(FPC_OPTIONS) -dDEBUG ${CASTLE_FPC_OPTIONS:-} @castle-fpc.cfg examples/android/drawing_toy/drawing_toy.lpr
	mkdir -p libs/armeabi/
	mv -f ../libdrawing_toy.so jni/libdrawing_toy.so
	export NDK_DEBUG=1 && ndk-build
	ant debug
#	adb uninstall net.sourceforge.castleengine.drawingtoy
	adb install -r bin/DrawingToy-debug.apk
	adb shell am start -a android.intent.action.MAIN -n net.sourceforge.castleengine.drawingtoy/android.app.NativeActivity

.PHONY: clean
clean:
	rm -Rf bin/ gen/ libs/ obj/ assets/ jni/libdrawing_toy.so

.PHONY: data
data:
	rm -Rf assets/
	cp -R ../data/ assets/
	find assets/ -type f \
	   '(' -iname '*~' -or \
	       -iname '*.blend1' -or \
	       -iname '*.blend2' ')' \
	   -exec rm -f '{}' ';'

=== src/ui/opengl/gui-images/Makefile ===
.PHONY: all clean

ALL_UNITS=../castlecontrolsimages.pas

all: $(ALL_UNITS)

clean:
	rm -f $(ALL_UNITS)

../castlecontrolsimages.pas: Panel.png PanelSeparator.png \
  Tooltip.png TooltipRounded.png \
  ButtonPressed.png ButtonFocused.png ButtonNormal.png \
  WindowDark.png WindowGray.png WindowDarkTransparent.png \
  ScrollbarFrame.png ScrollbarSlider.png Slider.png SliderPosition.png \
  FrameWhite.png FrameWhiteBlack.png FrameYellow.png FrameYellowBlack.png \
  FrameThickWhite.png FrameThickYellow.png \
  ProgressBar.png ProgressFill.png \
  TouchCtlInner.png TouchCtlOuter.png TouchCtlFlyInner.png TouchCtlFlyOuter.png
	image_to_pas --output .. CastleControlsImages \
	  Panel.png WindowDarkTransparent.png Slider.png \
	  Tooltip.png TooltipRounded.png \
	  ButtonPressed.png ButtonFocused.png ButtonNormal.png \
	  FrameWhite.png FrameWhiteBlack.png FrameYellow.png FrameYellowBlack.png \
	  FrameThickWhite.png FrameThickYellow.png ProgressBar.png ProgressFill.png \
	  TouchCtlInner.png TouchCtlOuter.png TouchCtlFlyInner.png TouchCtlFlyOuter.png\
	  @alpha=strip \
	  PanelSeparator.png WindowDark.png WindowGray.png \
	  ScrollbarFrame.png ScrollbarSlider.png \
	  SliderPosition.png

=== debian/changelog ===
castle-game-engine (5.0.0-3) unstable; urgency=medium

  * pasdoc finally entered Debian, so now build the documentation
  * Add upstream source for logo (from svn) and use it to build the png
  * Update d/TODO
  * Add d/gbp.conf to filter out upstream documentation during import

 -- Paul Gevers <elbrus@debian.org>  Sat, 30 Aug 2014 13:56:39 +0200

castle-game-engine (5.0.0-2) unstable; urgency=medium

  [ Abou Al Montacir ]
  * Force compilation of units in release mode in order to avoid FPC
    trying to recompile them during compilation of third party code.
   (Closes: #750486)

  [ Paul Gevers ]
  * Move maintainership to Pascal package team
  * Build depend on libfreetype6-dev, fixes FTBFS in Ubuntu (Closes: #748516)

 -- Paul Gevers <elbrus@debian.org>  Thu, 05 Jun 2014 21:26:23 +0200

castle-game-engine (5.0.0-1) unstable; urgency=medium

  [ Abou Al Montacir ]
  * New upstream release. (Closes: #747128)
  * Remove unused include file to allow building on systems where quilt is not
    installed

  [ Paul Gevers ]
  * Fix typo in package descriptions (Closes: #732760)
  * Remove nearly obsolete bzip compression for binary packages
    (See https://lists.debian.org/debian-devel/2014/01/msg00542.html)
  * Bump standards to 3.9.5 (no changes)
  * Converted copyright file to machine readable format and add notices for new
    files
  * Build Pascal source style font formats (using dejavu fonts package)
  * Strip piwik from documentation (thanks Lintian)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Fri, 13 Dec 2013 21:29:44 +0100

=== debian/control ===
Source: castle-game-engine
Section: misc
Priority: optional
Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
Uploaders:
 Abou Al Montacir <abou.almontacir@sfr.fr>,
 Paul Gevers <elbrus@debian.org>
Standards-Version: 3.9.5
Build-Depends:
 debhelper (>= 9),
 dh-exec,
 fonts-dejavu,
 fp-compiler,
 fp-units-base,
 fp-units-fcl,
 fp-units-gfx,
 fp-units-gtk2,
 fp-units-multimedia,
 fp-units-net,
 fp-utils (>= 2.6.2),
 libfreetype6-dev
Build-Depends-Indep:
 librsvg2-bin,
 pasdoc,
Vcs-Git: git://anonscm.debian.org/pkg-pascal/castle-game-engine.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-pascal/castle-game-engine.git
Homepage: http://castle-engine.sourceforge.net/engine.php

Package: fp-units-castle-game-engine
Architecture: amd64 i386
Built-Using: fonts-dejavu (= ${dejavu:version})
Depends:
 ${fpc-abi:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 castle-game-engine-src
Description: Castle Game Engine - 3D game engine for FreePascal / Lazarus
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains the FPC units.

Package: castle-game-engine-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Suggests:
 castle-game-engine-src,
 fp-units-castle-game-engine
Description: Castle Game Engine - Developer's Documentation
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains documentation.

Package: castle-game-engine-src
Section: doc
Architecture: all
Built-Using: fonts-dejavu (= ${dejavu:version})
Depends:
 fonts-dejavu,
 ${misc:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 fp-units-castle-game-engine
Description: Castle Game Engine - Source code for Lazarus integration
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains source code for integration with Lazarus RAD IDE.

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,6 @@
 # debian/rules for Castle Game Engine
 
 DEB_PACKAGE_NAME=castle-game-engine
-DEB_DH_BUILDDEB_ARGS := -- -Z bzip2
 export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
 export LANG:=C
 
@@ -28,6 +27,8 @@
 # Get version information from changelog file
 DEB_VERSION:=$(shell dpkg-parsechangelog | grep '^Version:' | cut -f 2 -d ' ')
 DEB_UPSTREAM_VERSION:=$(shell echo $(DEB_VERSION) | cut -f 1 -d -)
+# Used in dh-exec enhanced files
+export CGE_VERSION=${DEB_UPSTREAM_VERSION}
 DEB_UPSTREAM_MAIN_VERSION:=$(shell echo ${DEB_UPSTREAM_VERSION} | sed -e 's/^\([0-9\.]*\).*/\1/')
 DEB_BUILD=$(lastword $(subst -, ,${DEB_VERSION}))
 ifndef PACKAGESUFFIX
@@ -62,18 +63,14 @@
 # Set default compilation options
 BUILDOPTS=
 
-# Configure patch system
-include /usr/share/quilt/quilt.make
-
 #export DH_VERBOSE=1
 
 ###################
 # Clean
 #
 
-clean: patch configure clean-patched unpatch
-	# Remove auto-generated make files.
-	find -name Makefile.fpc -execdir 'sh' '-c' '${RM} $$(basename {} .fpc)' ';'
+clean: configure clean-patched
+	${MAKE} cleanall
 	# dh_clean gets a list of files from the debian/clean file
 	dh_clean
 clean-patched:
@@ -86,7 +83,7 @@
 # Arch packages
 #
 
-configure: patch configure-stamp
+configure: configure-stamp
 configure-stamp:
 	dh_testdir
 	# Remove auto-generated make files.
@@ -103,6 +100,13 @@
 build-arch-stamp:
 	@echo "--- Building"
 	dh_testdir
+	# Building Pascal style font file first
+	examples/fonts/texturefont2pascal_compile.sh
+	cd src/fonts ; PATH=${PATH}:../../examples/fonts ./mk_fonts.sh
+	# Unfortunately texturefont2pascal_compile.sh creates *.o and *.ppu
+	# files in the src tree, cleaning them now.
+	find . -name "*.o" -delete -o -name "*.ppu" -delete
+
 	${MAKE} all
 	touch build-arch-stamp
 
@@ -144,12 +148,14 @@
 # Documentation
 #
 
-build-doc: patch build-doc-stamp
+build-doc: build-doc-stamp
 build-doc-stamp:
 	@echo "--- Building Documentation"
 	dh_testdir
-	# Need to active the next line when pasdoc is packaged for Debian
-#	${MAKE} -C doc/pasdoc ${CONVERTER} ${BUILDOPTS}
+	${MAKE} -C doc/pasdoc ${DOCTYPE}
+	# The logo is stripped by the cleanall target. Building from source
+	rsvg-convert --width 256 --height 256 debian/castle_game_engine_icon.svg \
+		--output doc/pasdoc/html/castle_game_engine_icon.png
 	touch build-doc-stamp
 
 install-doc: build-doc install-doc-stamp
@@ -197,6 +203,7 @@
 	dh_installdocs -i -X.in
 	dh_installchangelogs -i
 	dh_install -i --list-missing
+	dh_link -i
 	dh_lintian
 
 ifeq (${DEB_BUILD},0)
@@ -213,7 +220,7 @@
 	dh_fixperms
 	dh_installdebconf -i
 	dh_installdeb -i
-	dh_gencontrol -i
+	dh_gencontrol -i -- -Vdejavu:version=`dpkg-query --show fonts-dejavu | awk '{print $$2}'`
 	dh_md5sums -i
 	dh_builddeb -i $(DEB_DH_BUILDDEB_ARGS)
 
@@ -221,7 +228,7 @@
 	@echo "--- Building: arch packages"
 	dh_testdir
 	dh_testroot
-	dh_link
+	dh_link -a
 	dh_installdocs -a -X.in
 	dh_installchangelogs -a
 	dh_installexamples -a
@@ -236,7 +243,7 @@
 	dh_installdebconf -a
 	dh_installdeb -a
 	dh_shlibdeps -s
-	dh_gencontrol -s
+	dh_gencontrol -s -- -Vdejavu:version=`dpkg-query --show fonts-dejavu | awk '{print $$2}'`
 	dh_md5sums -s
 	dh_builddeb -s $(DEB_DH_BUILDDEB_ARGS)

## castle-game-engine 5.1.1

=== Makefile ===
--- 
+++ 
@@ -116,7 +116,8 @@
   examples/resource_animations/resource_animations \
   examples/fps_game/fps_game \
   examples/2d/controls_demo \
-  examples/android/android_demo/androiddemo_standalone
+  examples/android/android_demo/androiddemo_standalone \
+  tools/castle-engine
 
 EXAMPLES_LAZARUS_BASE_NAMES := \
   examples/audio/test_al_source_allocator \
@@ -132,8 +133,7 @@
   $(EXAMPLES_LAZARUS_BASE_NAMES)
 
 EXAMPLES_WINDOWS_EXECUTABLES := $(addsuffix .exe,$(EXAMPLES_BASE_NAMES)) \
-  $(addsuffix .exe,$(EXAMPLES_LAZARUS_BASE_NAMES)) \
-  examples/fonts/outlinefont2pascal.exe
+  $(addsuffix .exe,$(EXAMPLES_LAZARUS_BASE_NAMES))
 
 EXAMPLES_MACOSX_APPS := $(addsuffix .app,$(EXAMPLES_BASE_NAMES)) \
   $(addsuffix .app,$(EXAMPLES_LAZARUS_BASE_NAMES))
@@ -172,6 +172,7 @@
 			   -iname '*.rsj' -or \
 			   -iname '*.compiled' -or \
 			   -iname '*.libimp*.a' -or \
+			   -iname '*.apk' -or \
 	                   -iname '*.dcu' -or -iname '*.dpu' -or \
 			   -iname 'castleengine.dll' -or -iname 'libcastleengine.so' ')' \
 	     -print \
@@ -187,8 +188,8 @@
 	rm -Rf fpmake fpmake.exe units/
 # lazarus produces lib/ subdirectories during compilation
 	find examples/ -type d -name lib -prune -exec rm -Rf '{}' ';'
-	$(MAKE) clean -C examples/android/android_demo/android/
-	$(MAKE) clean -C examples/android/drawing_toy/android/
+# clean every project with CastleEngineManifest.xml
+	find . -iname CastleEngineManifest.xml -execdir castle-engine clean ';'
 
 cleanmore: clean
 	find . -type f '(' -iname '*~' -or \

=== debian/changelog ===
castle-game-engine (5.1.1-2) unstable; urgency=medium

  * Upload to unstable
  * Prevent timestamps in documentation to allow builds to be reproducible

 -- Paul Gevers <elbrus@debian.org>  Sat, 16 May 2015 08:16:57 +0200

castle-game-engine (5.1.1-1) experimental; urgency=medium

  * New upstream release
  * Drop obsolete patch
  * Fix typo in test suite (failed on i386) by upstream commit 14349.
    Yah for running test suites.

 -- Paul Gevers <elbrus@debian.org>  Sat, 10 Jan 2015 19:30:14 +0100

castle-game-engine (5.1.0-1) experimental; urgency=medium

  * New upstream release
  * Update patches
  * Expend d/clean to avoid using embedded font files
  * Drop more font pascal files in d/gbp.conf
  * Build-Depends-Indep on inkscape iso librsvg2-bin to build icon and
    drop d/rules logic as upstream now provides the logic
  * Bump Standards-Version to 3.9.6 (no changes)
  * Remove d/castle_game_engine_icon.svg, now included upstream
  * Run test suite at build time (and add Build-Depends for it)
    - Add upstream patch to remove irrelevant test case that fails to build
  * Fix d/copyright (thanks Lintian)

 -- Paul Gevers <elbrus@debian.org>  Mon, 29 Dec 2014 09:09:44 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Abou Al Montacir <abou.almontacir@sfr.fr>,
  Paul Gevers <elbrus@debian.org>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Build-Depends:
  debhelper (>= 9),
  dh-exec,
@@ -18,9 +18,15 @@
  fp-units-multimedia,
  fp-units-net,
  fp-utils (>= 2.6.2),
- libfreetype6-dev
+ libatk1.0-dev,
+ libcairo2-dev,
+ libfreetype6-dev,
+ libgdk-pixbuf2.0-dev,
+ libgtk2.0-dev,
+ libgtkglext1-dev,
+ libpango1.0-dev,
 Build-Depends-Indep:
- librsvg2-bin,
+ inkscape,
  pasdoc,
 Vcs-Git: git://anonscm.debian.org/pkg-pascal/castle-game-engine.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-pascal/castle-game-engine.git

=== debian/rules ===
--- 
+++ 
@@ -41,6 +41,7 @@
 LIB_DIR=${INSTALL_DIR}/usr/lib/${DEB_PACKAGE_NAME}/${DEB_UPSTREAM_MAIN_VERSION}
 SRC_DIR=${INSTALL_DIR}/usr/src/${DEB_PACKAGE_NAME}-${DEB_UPSTREAM_MAIN_VERSION}
 UNITS_DIR=${INSTALL_DIR}/usr/lib/${DEB_HOST_MULTIARCH}/fp-units-${FPCVER}/${DEB_PACKAGE_NAME}-${DEB_UPSTREAM_MAIN_VERSION}
+TMP_DIR=${INSTALL_DIR}/tmp
 # Get utils
 ifndef MKDIR
 MKDIR=mkdir -p
@@ -100,14 +101,25 @@
 build-arch-stamp:
 	@echo "--- Building"
 	dh_testdir
-	# Building Pascal style font file first
-	examples/fonts/texturefont2pascal_compile.sh
-	cd src/fonts ; PATH=${PATH}:../../examples/fonts ./mk_fonts.sh
-	# Unfortunately texturefont2pascal_compile.sh creates *.o and *.ppu
-	# files in the src tree, cleaning them now.
-	find . -name "*.o" -delete -o -name "*.ppu" -delete
+	# Building Pascal style font file first while making sure that
+	# no unit or object files polute the source tree
+	${MKDIR} ${TMP_DIR}
+	${FPC} -FE${TMP_DIR}  @castle-fpc.cfg examples/fonts/texturefont2pascal.lpr
+	cd src/fonts ; PATH=${PATH}:${TMP_DIR} ./mk_fonts.sh
 
 	${MAKE} all
+
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	# Code to run the package test suite.
+	# Command basically copied from tests/compile_console.sh while
+	# making sure that no unit or object files polute the source tree
+	${FPC}  -gh -dDEBUG -dTEXT_RUNNER -dNO_WINDOW_SYSTEM "$@" \
+		-Fuexamples/shadow_fields/ -FE${TMP_DIR} \
+		@castle-fpc.cfg tests/test_castle_game_engine.lpr
+	# cd is needed to find the data files
+	cd tests ; ${TMP_DIR}/test_castle_game_engine -a
+endif
+
 	touch build-arch-stamp
 
 install-arch: build-arch install-arch-stamp
@@ -135,7 +147,7 @@
 		${MKDIR} "$${pkgDir}" ; \
 		sed -e 's@\(\W*\)<CompilerOptions>.*@\1<AutoUpdate Value="Manually"/>\n&@' \
 		    -e "s@\.\./src/@$$(relpath ${SRC_DIR} $${pkgDir})/@g" \
-			-e "s@\(\W*\)<UnitOutputDirectory .*@<UnitOutputDirectory Value=\"$$(relpath ${UNITS_DIR} $${pkgDir})\"/>@" \
+		    -e "s@\(\W*\)<UnitOutputDirectory .*@<UnitOutputDirectory Value=\"$$(relpath ${UNITS_DIR} $${pkgDir})\"/>@" \
 		    "$${package}" > "${LIB_DIR}/$${package}" ; \
 	done
 	find ${INSTALL_DIR} -empty -delete
@@ -153,9 +165,6 @@
 	@echo "--- Building Documentation"
 	dh_testdir
 	${MAKE} -C doc/pasdoc ${DOCTYPE}
-	# The logo is stripped by the cleanall target. Building from source
-	rsvg-convert --width 256 --height 256 debian/castle_game_engine_icon.svg \
-		--output doc/pasdoc/html/castle_game_engine_icon.png
 	touch build-doc-stamp
 
 install-doc: build-doc install-doc-stamp
@@ -202,7 +211,7 @@
 	dh_testroot
 	dh_installdocs -i -X.in
 	dh_installchangelogs -i
-	dh_install -i --list-missing
+	dh_install -i -Xtmp/tmp/ --list-missing
 	dh_link -i
 	dh_lintian
 
@@ -232,7 +241,7 @@
 	dh_installdocs -a -X.in
 	dh_installchangelogs -a
 	dh_installexamples -a
-	dh_install -a --list-missing
+	dh_install -a -Xtmp/tmp/ --list-missing
 	dh_lintian
 	dh_installmenu
 	fpc-depends
